package com.jiuqi.grid;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.Serializable;

public final class CellField implements Serializable, Cloneable, Comparable {
  public int left;
  
  public int top;
  
  public int right;
  
  public int bottom;
  
  public static final int FIELDS_EQUAL = 0;
  
  public static final int FIELDS_CONTAIN = 1;
  
  public static final int FIELDS_INSIDE = -1;
  
  public static final int FIELDS_EXCLUDE = 2;
  
  public static final int FIELDS_CROSS = -2;
  
  public CellField() {}
  
  public CellField(int l, int t, int r, int b) {
    this.left = l;
    this.top = t;
    this.right = r;
    this.bottom = b;
  }
  
  public CellField(com.jiuqi.grid.CellField field) {
    this.left = field.left;
    this.top = field.top;
    this.right = field.right;
    this.bottom = field.bottom;
  }
  
  public int getArea() {
    return (this.right - this.left + 1) * (this.bottom - this.top + 1);
  }
  
  public boolean inField(int x, int y) {
    return (x >= this.left && x <= this.right && y >= this.top && y <= this.bottom);
  }
  
  public com.jiuqi.grid.CellField makeCopy() {
    return (com.jiuqi.grid.CellField)clone();
  }
  
  public boolean equals(Object o) {
    if (this == o)
      return true; 
    if (!(o instanceof com.jiuqi.grid.CellField))
      return false; 
    com.jiuqi.grid.CellField field = (com.jiuqi.grid.CellField)o;
    return (this.left == field.left && this.top == field.top && this.right == field.right && this.bottom == field.bottom);
  }
  
  public int hashCode() {
    return this.left << 24 ^ this.top << 16 ^ this.right << 8 ^ this.bottom;
  }
  
  public String toString() {
    StringBuffer buffer = new StringBuffer("[(");
    buffer.append(this.left);
    buffer.append(",");
    buffer.append(this.top);
    buffer.append("),(");
    buffer.append(this.right);
    buffer.append(",");
    buffer.append(this.bottom);
    buffer.append(")]");
    return buffer.toString();
  }
  
  public boolean containField(com.jiuqi.grid.CellField field) {
    return (this.left <= field.left && this.top <= field.top && this.right >= field.right && this.bottom >= field.bottom);
  }
  
  public Object clone() {
    try {
      return super.clone();
    } catch (CloneNotSupportedException cloneNotSupportedException) {
      return null;
    } 
  }
  
  public static int compareField(com.jiuqi.grid.CellField field1, com.jiuqi.grid.CellField field2) {
    if (field1.equals(field2))
      return 0; 
    if (field1.containField(field2))
      return 1; 
    if (field2.containField(field1))
      return -1; 
    if (field1.inField(field2.left, field2.top) || field1.inField(field2.right, field2.bottom))
      return -2; 
    if (field1.inField(field2.left, field2.bottom) || field1.inField(field2.right, field2.top))
      return -2; 
    return 2;
  }
  
  public int compareTo(Object o) {
    if (o == this)
      return 0; 
    if (o == null)
      return 1; 
    if (o instanceof com.jiuqi.grid.CellField) {
      com.jiuqi.grid.CellField f = (com.jiuqi.grid.CellField)o;
      int retCode = this.left - f.left;
      if (retCode != 0)
        return retCode; 
      retCode = this.top - f.top;
      if (retCode != 0)
        return retCode; 
      retCode = this.right - f.right;
      if (retCode != 0)
        return retCode; 
      return this.bottom - f.bottom;
    } 
    return 1;
  }
}
